/*
 *  sicoconplug.cpp
 *  PhatBoy Control
 *
 *  Created by Arne Scheffler on Sat Feb 22 2003.
 *  Copyright (c) 2003 Arne Scheffler. All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define INIT_CLASS_IID

#ifndef __pluginfactory__
#include "pluginfactory.h"
#endif

#ifndef __sicocon__
#include "sicocon.h"
#endif

//------------------------------------------------------------------------
//  Plug-In factory information
//------------------------------------------------------------------------

static PFactoryInfo factoryInfo =
{
	"Arne Scheffler",
	"http://arne.knup.de",
	"mailto:arne@knup.de",
	PFactoryInfo::kNoFlags
};

//------------------------------------------------------------------------
//  exported class
//------------------------------------------------------------------------

static PClassInfo pluginClass =
{
	INLINE_UID (0x4539D677, 0x474111D7, 0x81E50003, 0x930B0DAE),
	PClassInfo::kManyInstances,	
	kMidiModuleClass,
	"PhatBoy Control"
};

//------------------------------------------------------------------------
//  module init/exit
//------------------------------------------------------------------------

bool InitModule ()   { return true; }
bool DeinitModule () { return true; }

//------------------------------------------------------------------------
//  Steinberg Plug-In entry
//------------------------------------------------------------------------
#if __MWERKS__
#pragma export on
#endif

IPluginFactory* PLUGIN_API GetPluginFactory ()
{	
	if(!gPluginFactory)
	{
		gPluginFactory = new CPluginFactory (factoryInfo);
		gPluginFactory->registerClass (&pluginClass, SiCoCon::createInstance, pluginClass.cid);
	}
	else
		gPluginFactory->addRef ();

	return gPluginFactory;
}

#if __MWERKS__
#pragma export off
#endif
